{$q+,r+,o-}
{$APPTYPE console}
const
    eps = 1e-15;
    max_n = 1000;
    s = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ. ';

function f(p: double; n, k: longint): double;
begin
    f := -(p * ln(p / k) + (1 - p) * ln((1 - p) / (n- k))) / ln(2);
end;

function f2(p, cp, q, cq: double): double;
var
    t: double;
begin
    if (p = 0) or (q = 0) then begin
        f2 := 0;
    end else begin
        t := p * cp + q * cq;
        f2 := -(cp * p * ln(p / t) + cq * q * ln(q / t)) / ln(2) / t;
    end;
end;

var
    i, j, n: longint;
    e: double;
    l, r, m: double;
    p, q, mn: longint;    
    d: extended;
begin
    read(e);

    n := 2;
    while ln(n) / ln(2) <= e - eps do begin
        inc(n);
    end;

    l := 1 / n;
    r := 1;

    while (r - l) > eps do begin
        m := (r + l) / 2;
        if f(m, n, 1) > e then begin
            l := m;
        end else begin
            r := m;
        end;
    end;

    m := (l + r) / 2;

    mn := 0;
    for i := max_n downto 1 do begin
        p := round(m * i);
        q := round((1 - m) / (n - 1) * i);
        d := abs(e - f2(p, 1, q, n - 1));
        if d < 0.0049 then begin
            if p + q * (n - 1) < max_n then begin
                mn := i;
            end;
        end;
    end;

    p := round(m * mn);
    q := round((1 - m) / (n - 1) * mn);

    for j := 1 to p do begin
        write(s[1]);
    end;

    for i := 2 to n do begin
        for j := 1 to q do begin
            write(s[i]);
        end;
    end;

    close(input);
    close(output);
end.